unit BMP2TEX1;

// My Texture file format (C)2002 by Paul TOTH <tothpaul@free.fr>

{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtDlgs, ExtCtrls, StdCtrls, jpeg, pcx, tex;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Label4: TLabel;
    Shape1: TShape;
    Label5: TLabel;
    Shape2: TShape;
    Label6: TLabel;
    Shape3: TShape;
    OpenPictureDialog1: TOpenPictureDialog;
    SaveDialog1: TSaveDialog;
    Label7: TLabel;
    Alpha: TCheckBox;
    lbFileName: TLabel;
    procedure Label4Click(Sender: TObject);
    procedure Label6Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Label5Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Label4Click(Sender: TObject);
var
 s:string;
begin
 if OpenPictureDialog1.Execute then begin
  s:=OpenPictureDialog1.FileName;
  lbFileName.Caption:=s;
  Image1.Picture.LoadFromFile(s);
 end;
end;

procedure TForm1.Label6Click(Sender: TObject);
begin
 Application.Terminate;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 Ctl3D:=False;
end;

Function PowerOf2(Target:integer):integer;
 begin
  Result:=1;
  while Result<Target do Result:=Result shl 1;
 end;

procedure RGB2BGR(var p);
 var
  i:array[0..2] of byte absolute p;
  t:byte;
 begin
  t:=i[2]; i[2]:=i[0]; i[0]:=t;
 end;

procedure TForm1.Label5Click(Sender: TObject);
var
 s:TFileStream;
 b:TBitmap;
 r:TRect;
 t:packed record
    sign  :word;
    depth :word;
    width :integer;
    height:integer;
   end;
 x,y,z:integer;
 p:pchar;
 tex:TTEXImage;
begin
 if SaveDialog1.Execute then begin

  tex:=TTEXImage.Create;
  tex.Assign(Image1.Picture.Graphic);
  tex.SaveToFile(SaveDialog1.FileName);
  tex.free;

  EXIT;

  s:=TFileStream.Create(SaveDialog1.FileName,fmCreate);

  t.sign:=$DD3D;
  if Alpha.Checked then begin
   t.depth:=4;
  end else begin
   t.depth:=3;
  end;
  t.width :=PowerOf2(Image1.Width);
  t.Height:=PowerOf2(Image1.Height);

  b:=TBitmap.Create;
  if t.depth=4 then b.PixelFormat:=pf32bit else b.Pixelformat:=pf24bit;
  b.Width :=t.width;
  b.Height:=t.Height;
  r:=Rect(0,0,t.Width,t.Height);
  b.Canvas.StretchDraw(r,Image1.Picture.Graphic);

  p:=b.ScanLine[t.Height-1];
  for y:=0 to t.Height-1 do
   for x:=0 to t.Width-1 do begin
    RGB2BGR(p[0]);
    inc(p,t.depth);
   end;

  p:=b.ScanLine[t.Height-1];
  s.WriteBuffer(t,sizeof(t));
  s.WriteBuffer(p^,t.width*t.height*t.depth);

  s.Free;

 end;
end;

end.
